
!!! tip "Atención"

    La fecha inicial en Calc y en Python son diferentes.

<br>

### **today**

Obtener la fecha actual.

```py
    d = app.dates
    app.msgbox(d.today)
```

<br>

### **now**

Obtener la fecha y hora actuales.

```py
    d = app.dates
    app.msgbox(d.now)
```

<br>

### **time**

Obtener la hora actual.

```py
    d = app.dates
    app.msgbox(d.now.time())
```

<br>

### **epoch**

Obtener el [tiempo Unix][1]

```py
    d = app.dates
    app.msgbox(d.epoch)
```

<br>

### **date**

Devolver una fecha

```py
    d = app.dates

    date = d.date(1974, 1, 15)
    app.msgbox(date)
```

<br>

### **time**

Devolver una hora

```py
    d = app.dates

    time = d.time(10, 20, 15)
    app.msgbox(time)
```

<br>

### **datetime**

Devolver fecha y hora

```py
    d = app.dates

    dt = d.datetime(1974, 1, 15, 10, 11, 12)
    app.msgbox(dt)
```

<br>

### **str_to_date**

Convertir una cadena en fecha. Mira este [excelente recurso][2]

```py
    d = app.dates

    cadena = '1974-01-15'
    plantilla = '%Y-%m-%d'
    fecha = d.str_to_date(cadena, plantilla)
    app.msgbox(fecha)
    app.msgbox(type(fecha))
```

Para obtener un valor válido para establecer en una celda de Calc.

```py
    d = app.dates

    cadena = '1974-01-15'
    plantilla = '%Y-%m-%d'
    fecha = d.str_to_date(cadena, plantilla, True)
    app.msgbox(fecha)
    app.msgbox(type(fecha))
```

<br>

### **calc_to_date**

Convierte el valor de una celda en una fecha Python, por ejemplo, la fecha inicial configurada en Calc.

```py
    d = app.dates

    valor_en_celda = 0
    fecha = d.calc_to_date(valor_en_celda)
    app.msgbox(fecha)
    app.msgbox(type(fecha))
```

<br>

### **sleep**

Pausar la ejecución por X segundos.

!!! tip inline end "Atención"

    La pausa es bloqueante.

```py
    d = app.dates

    app.sleep(3)
    app.msgbox('Fin')
```

<br>

### **start** y **end**

Medir tiempo en segundos.

```py
    d = app.dates

    d.start()
    app.sleep(5)
    seconds = d.end()
    app.msgbox(seconds)
```

Regresar timedelta en vez de segundos.

```py
    d = app.dates

    d.start()
    app.sleep(5)
    td = d.end(False)
    app.msgbox(td)
```


[1]: https://es.wikipedia.org/wiki/Tiempo_Unix
[2]: https://strftime.org
