Gracias a [mureq](https://github.com/slingamn/mureq) una sencilla librería para hacer peticiciones HTTP, similar a [requests](https://requests.readthedocs.io) pero más sencilla y en un solo archivo.

### **get**

Método `get`.

```py
def prueba_get():

    url = 'https://api.ipify.org'
    respuesta = app.url.get(url)
    if respuesta.status_code == 200:
        mi_ip = respuesta.body.decode()
        app.debug(f'IP: {mi_ip}')
    else:
        app.debug(respuesta.status_code)

    return
```

```sh
16/08/2022 22:14:13 - DEBUG - IP: 199.203.174.159
```

<br>

#### **json**

Respuestas en formato json.

```py
def prueba_get():

    url = 'https://api.ipify.org/?format=json'
    respuesta = app.url.get(url)
    if respuesta.status_code == 200:
        datos = respuesta.json()
        app.debug(f'IP: {datos["ip"]}')
    else:
        app.debug(respuesta.status_code)

    return
```

<br>

## **post**

Método `post`

```py
def prueba_post():

    url = 'https://translate.terraprint.co/translate'
    data = dict(
        q = 'Hello World',
        source = 'en',
        target = 'es',
    )
    respuesta = app.url.post(url, json=data)
    if respuesta.status_code != 200:
        app.debug(respuesta.status_code)
        return

    datos = respuesta.json()
    app.debug(datos)

    return
```

```sh
elmau@oficina ~> soffice --calc
22/04/2023 14:57:50 - DEBUG - {'translatedText': 'Hola Mundo'}
```

<br>